#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "tcl.h"

int formatnum(ClientData, Tcl_Interp *, int, char **);

int formatnum_init(interp)
Tcl_Interp *interp;
{
	Tcl_CreateCommand(interp, "formatnum", formatnum,
		(ClientData)0L, (void (*)())NULL);

	return TCL_OK;
}

int formatnum(dummy, interp, argc, argv)
ClientData dummy;
Tcl_Interp *interp;
int argc;
char **argv;
{
	char numstr[20];
	char numstrret[25];
	char numstrret2[25];
	int x = 0, y = 0, z = 0;

	if(argc != 2) {
		Tcl_AppendResult(interp, "wrong # args: should be ", argv[0],
				" <number>", (char *)NULL);
		return TCL_ERROR;
	}

	strcpy(numstr, argv[1]);

	if(strlen(numstr) > 10) {
		Tcl_AppendResult(interp, "number too large.  10 digits only", 
				(char*)NULL);
		return TCL_ERROR;
	}

	memset(numstrret, '0', sizeof(numstrret));

	z = 24;
	numstrret[25] = '\0';

	for(x = strlen(numstr); x >= 0; x--) {
		if(isdigit(numstr[x])) {
			if(y == 3) {
				numstrret[z] = ',';
				z--;
				y = 0;
			}
			numstrret[z] = numstr[x];
			z--;
			y++;
		}
	}

	for(x = 0; x < 25; x++) {
		if(numstrret[x] != '0') {
			break;
		}
	}

	z = 0;

	for(y = x; y < 25; y++) {
		numstrret2[z] = numstrret[y];
		z++;
	}

	numstrret2[z] = '\0';

	Tcl_AppendResult(interp, numstrret2, (char *)NULL);
	return TCL_OK;
}
